﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Controls.Grids;

namespace CustomGridColumnsDemo.Assets.Columns
{
    public class ComboBoxColumnContentProvider : ColumnContentProviderBase
    {
        #region Members

        TextBlock _tb;
        ComboBox _combobox;

        #endregion

        #region Constructor

        public ComboBoxColumnContentProvider()
        {
            _tb = new TextBlock();
            _combobox = new ComboBox();
        }

        #endregion

        #region Overrides

        #region ResolveDisplayElement

        public override FrameworkElement ResolveDisplayElement(Cell cell, System.Windows.Data.Binding cellBinding)
        {
            ComboBoxColumn column = (ComboBoxColumn)cell.Column;

            Binding textBinding = new Binding();

            if (column.DisplayMemberPath!=null)
                textBinding.Path = new PropertyPath(string.Format("{0}.{1}", column.Key, column.DisplayMemberPath));
            else
                textBinding.Path = new PropertyPath(column.Key);

            textBinding.Mode = BindingMode.TwoWay;
            this._tb.SetBinding(TextBlock.TextProperty, textBinding);

            return _tb;
        }

        #endregion

        #region ResolveEditorControl

        protected override FrameworkElement ResolveEditorControl(Cell cell, object editorValue, double availableWidth, double availableHeight, System.Windows.Data.Binding editorBinding)
        {
            ComboBoxColumn column = (ComboBoxColumn)cell.Column;

            this._combobox.SetValue(ComboBox.ItemsSourceProperty, column.ItemsSource);

            if (column.DisplayMemberPath!=null)
                this._combobox.SetValue(ComboBox.DisplayMemberPathProperty, column.DisplayMemberPath);

            Binding selectedItemBinding = new Binding();
            selectedItemBinding.Source = cell.Row.Data;
            selectedItemBinding.Path = new PropertyPath(column.Key);
            selectedItemBinding.Mode = BindingMode.TwoWay;

            this._combobox.SetBinding(ComboBox.SelectedItemProperty, selectedItemBinding);

            this._combobox.Style = cell.EditorStyleResolved;

            return this._combobox;
        }

        #endregion

        #region ResolveValueFromEditor

        public override object ResolveValueFromEditor(Infragistics.Controls.Grids.Cell cell)
        {
            return this._combobox.SelectedItem;
        }

        #endregion

        #endregion
    }
}
