﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Data;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Editors;
using System.Globalization;

namespace CustomGridColumnsDemo.Assets.Columns
{
    class DateTimeColumnContentProvider : DateColumnContentProvider
    {
        TextBlock _displayElement;
        private XamDateTimeInput _editorElement;

        public DateTimeColumnContentProvider()
        {
            _displayElement = new TextBlock();
            _editorElement = new XamDateTimeInput();
        }
     

        public override FrameworkElement ResolveDisplayElement(Cell cell, Binding cellBinding)
        {
            _displayElement.SetBinding(TextBlock.TextProperty, cellBinding);

            return _displayElement;
        }

        public override object ResolveValueFromEditor(Cell cell)
        {
            return _editorElement.Value;
        }

        protected override FrameworkElement ResolveEditorControl(Cell cell, object editorValue, double availableWidth, double availableHeight, Binding editorBinding)
        {
            _editorElement.SetBinding(XamDateTimeInput.ValueProperty, editorBinding);

            return this._editorElement;
        }
    }
    
    

}
